#!/usr/bin/env python
# -*- coding: utf-8 -*-

# $Id: pdfgen.py 82 2011-02-18 07:44:15Z kkumer $ 

"""Handling input of HTML form from abs.py CGI script.
   Puts data in database and creates PDF document.

kkumer@phy.hr 2003-03-27 
"""

PWD_PROTECTED = 1
execfile('../cgi_init.py')  # CGI initialization

import commands, re, types



def die(message):
    doc.append(message)
    if cfg['DEBUG']: doc.append(str(form))
    doc.append(back)
    doc.append(foot % today)
    doc.write()
    sys.exit(1)

# Producing HTML report
ttl = "Potvrda prijave sažetka - %s %s" % (uname, usurname)
ctype = Meta(equiv="Content-Type",
           content="text/html; charset=utf-8")

css = cfg['HTML_LINK'] + "coonf.css"

doc = SimpleDocument(title=ttl, stylesheet=css)

# head
head, foot = extractHF()
doc.append(head)

## HTML form for going back
back = Form(cgi=cfg['CGI_LINK']+"home.py",
         submit=Input(type="submit", value="Natrag na Vašu osobnu početnu stranicu"))
back.append(Input(type="hidden", name="pwd", value=pwd))

doc.append(Heading(2, ttl))

# First check that necessary data are here
if not form.has_key('title'):
    die("Nema naslova?! Pokušajte ponovno:")
if not form.has_key('body'):
    die("Nema samog sadržaja sažetka?! Pokušajte ponovno:")
for n in map(str, range(1,20)):
    if form.has_key('authorname'+n) or form.has_key('authorsurname'+n):
        if cfg['DEBUG']: doc.append("No: " + n)
        if not form.has_key('authorname'+n):
            die("Autori moraju imati i ime i prezime! Pokušajte ponovno:")
        if not form.has_key('authorsurname'+n):
            die("Autori moraju imati i ime i prezime! Pokušajte ponovno:")
            
# Other items can be recreated

# Create dictionary a, and pickle it into the database
a = {}

a['title'] = form['title'].value

br = '1'
a['authors']=[]
for n in map(str, range(1,20)):
    if form.has_key('authorname'+n):
        # ugly hack, this one:
        if form.has_key('authoremail'+n):
            email = form['authoremail'+n].value
        else:
            email = ""
        a['authors'].append((form['authorname'+n].value,
                             form['authorsurname'+n].value,
                             email,
                             form['authorinstid'+n].value))
        br = str(int(br)+1)

br = '1'
a['institutions']=[]
for n in map(str, range(1,20)):
    if form.has_key('instname'+n):
        a['institutions'].append((br, form['instname'+n].value)),
        br = str(int(br)+1)

a['body'] = form['body'].value

br = '1'
a['refs']=[]
for n in map(str, range(1,20)):
    if form.has_key('ref'+n):
        a['refs'].append((br, form['ref'+n].value)),
        br = str(int(br)+1)

# pacs can have multiple values
pacs = form.getvalue('pacs', '')
if isinstance(pacs, types.ListType):
    a['pacs'] = ",".join(pacs)
else:
    a['pacs'] = pacs

update(cursor, uid, a)

doc.append("<BR><P>")
doc.append("(1) Unos podataka obavljen.<P>")
doc.append("Prelazim na slog sažetka za tisak.<P>")
doc.append("-----------------------------------------<P>")

# Create PDF
## Reading in the LaTeX template file
f = open("template.tex", "r")
tex = f.read()
f.close()

## Page number = UID
tex = string.replace(tex, "@UID", str(uid))

## Title
tex = string.replace(tex, "@TITLE", a['title'])

## Authors 
authors = ""
for n in range(len(a['authors'])):
    author = Author(a['authors'][n])
    authors = authors + author.name + " " + author.surname +\
                "$^{" + author.instid + "}$,\n"
authors = authors[:-2]  # removing last comma and \n
tex = string.replace(tex, "@AUTHORS", authors)
    
## Institutions 
institutions = ""
for n in range(len(a['institutions'])):
    institution = a['institutions'][n]
    institutions = institutions + "$^{" + institution[0] + "}$" +\
                        institution[1] + r"\\" + "\n"
institutions = institutions[:-3]  # removing last \\ and \n
tex = string.replace(tex, "@INSTITUTIONS", institutions)

## Body
tex = string.replace(tex, "@BODY", a['body'])

## References
refs = ""
for n in range(len(a['refs'])):
    ref = a['refs'][n]
##     refs = refs + "\item{[" + ref[0] + "]}\n" + ref[1] + "\n"
    refs = refs + "\myitem{[" + ref[0] + "]}{" + ref[1] + "}\n"
tex = string.replace(tex, "@REFS", refs)

## Generating LaTeX
os.chdir(cfg['PDFDIR'])
f = open('sazetak%s.tex' % str(uid), 'w')
f.write(tex)
f.close()

## LaTeXing
c = commands.getstatusoutput(cfg['PDFLATEX'] + ' sazetak%s.tex' % str(uid))
f = open('sazetak%s.plog' % str(uid), 'w')
f.write(c[1])
f.close()

if c[0]:
    doc.append("""(2) Pri slaganju Vašeg sažetka za tisak su se pojavili 
  <SPAN style="color:white; background:red">problemi</SPAN>. Vjerojatno
             ste upotrijebili neki od zabranjenih znakova ili ste neispravno
             upotrijebili LaTeX komande. Vratite se na početnu stranicu i
             korigirajte unos. Pročitajte pažljivo kratke
             <A HREF="%slatex.html">LaTeX upute</A>.<P> 
             Evo dolje relevatnog izvatka koji Vam možda može pomoći: <pre>""" %
             cfg['HTML_LINK'])
    ## HTML form for going back
    doc.append(back)

    # Removing uninteresting header lines
    #head = re.compile(r'This.*omxpsycm\.fd\)', re.DOTALL)
    head = re.compile(r'This.*omspzccm\.fd\)', re.DOTALL)
    morefonts = re.compile(r'\(/usr/local.*omxpsycm\.fd\)', re.DOTALL)
    log = head.sub("", c[1])
    log = morefonts.sub("", log)
    # Coloring the error line red
    err = re.compile(r'(^! .*$)', re.MULTILINE)
    log = err.sub('<DIV style="color:white; background:red">\\1</DIV>', log)
    doc.append(log)
    doc.append("</pre>")
    doc.append(foot % today)
    doc.write()
    sys.exit(1)

# END PDF

doc.append("""(2) Vaši upravo uneseni podaci su spremljeni i sažetak je
uspješno složen za tisak.<BR>
Izgled Vašeg sažetka složenog za tisak možete provjeriti
s Vaše početne stranice.<P> """)

## Checking number of pages
pat = re.compile(r'Output written .*\(([0-9]+) pag')
m = pat.search(c[1])
if m:  # Something is generated
    nopages = int(m.groups()[0])
    doc.append("""<div class="bigred">Broj izgeneriranih stranica:  %s </div>
                 """ % str(nopages))
    if nopages > 1:
        doc.append("""<BR><div class="bigred"> Budući da sažetak mora 
             stati na jednu tiskanu 
             stranicu, molimo Vas da se vratite natrag i korigirate unos.</div><BR>
            (Pogledajte prvo složeni članak da dobijete osjećaj koliko
             materijala morate maknuti.)""")


doc.append(back)


doc.append("""<BR><P><BR><P>
<FONT size="-1">
(Ako ste samo tražili dodatna polja za unos i stigli na ovu
stranicu, onda ste pogrešno
pritisnuli gumb [Prijavi] na dnu stranice, a trebali ste
pritisnuti gumb [Zatraži] neposredno ispod vaših zahtjeva.
Vratite se natrag i pokušajte ponovno.) </FONT> """)


# writing it out
doc.append(foot % today)
doc.write()
