#!/usr/bin/env python

# $Id: register.py 82 2011-02-18 07:44:15Z kkumer $

### This script takes input from HTML form and
### a) writes data to the database
### b) emails data both to participant and administrator
### c) returns data to participant's WWW browser
### d) optionaly creates initial abstract entry


PWD_PROTECTED = 0
execfile('cgi_init.py')  # CGI initialization

import re,sys,smtplib,types
from email.MIMEText import MIMEText

## Generating HTML page head
ttl = "Registration"
doc = SimpleDocument(title=ttl, stylesheet=cfg['CSS_FILE'])
doc.append(head)
doc.append(Heading(1,ttl))

# First check that all obligatory input is here
def die(message):
    """Returns HTML code of error message, ends HTML page, and exits
       die(string) -> string (HTML code)
    """
    doc.append(message)
    doc.append(foot % today)
    doc.write()
    sys.exit(1)

missing = 0
for item in FieldList():
    if item.obligatory.lower() == 'y' and not form.has_key(item.name):
        doc.append('Obligatory item "<b>' + item.description \
                    +  '</b>" is missing!<BR>')
        missing = missing + 1
if missing > 0:
    doc.append("<PRE>-------------------------------------------</PRE><BR><P>")
    die("Please, press [BACK] button on \
        your WWW browser and enter the missing data.")


names = ['appdate']
values = [today['UPDATE']]
descriptions = ['Application_date']

for item in FieldList():
    names.append(item.name)
    descriptions.append(item.description)
    tmpvalue = form.getvalue(item.name,item.default)
    if isinstance(tmpvalue, types.ListType):
        # Multiple fields specified
        values.append(\
         MySQLdb.escape_string(unicode(",".join(tmpvalue),'utf-8')))
    else:
        # Single or no field specified
        values.append(MySQLdb.escape_string(unicode(tmpvalue, 'utf-8')))


# [1] Writing entered data into database

cursor = getCursor()

qry = 'INSERT INTO people (%s) VALUES (%s);' % \
        (",".join(names), ",".join(map(lambda x: "'%s'" % x, values)))
cursor.execute(qry)

# get id given by database by this INSERT
qry = 'SELECT id FROM people where email = "%s";' % form['email'].value
cursor.execute(qry)
res = cursor.fetchall()
id = res[-1][0] # The last of the entered emails; paranoic
pwd = makepwd(id) # URL password for everything


# [1b] Creating initial entry in "abstracts" table.
if cfg['MODULE_ABSTRACTS']:
    a = {}
    if form.has_key('prestitle'):
        a['title'] =  form['prestitle'].value
    else:
        a['title'] = "Title"

    a['authors'] = [("First", "Author", "her@email.hr", "1"), 
                 ("Second", "Author", "his@email.hr", "2")]
    a['institutions'] = [("1", "Institute One"), ("2", "Institute Two")]
    a['body'] = """ This is an example of abstract.
     {\\em Careful} with formulae: $ E = m c^{2} $!
     This is 100 \\% great. Use boldface in references only!

     Empty row starts a new paragraph.

    """
    a['refs'] = [("1", "Reference One, Nature {\\bf 23} (2003) 1"), 
                 ("2", "Reference Two, Phys. Rev. Lett {\\bf 91} (2003) 68")]

    a['pacs'] = ""

    put(cursor, id, a)


releaseCursor(cursor)

# [2] Emailing

load = '\n\n Dear colegue, \n' 
load = load + """
Thank you for you application.  Below is data you entered.
"""

if cfg['MODULE_ABSTRACTS']:
    load = load + """
Abstract of your contribution can be entered on

    %shome.py?pwd=%s
""" % (cfg['ABS_CGI_LINK'], pwd)

if cfg['MODULE_UPLOADS']:
    load = load + """
Your contribution to proceedings can be uploaded on

    %shome.py?pwd=%s
""" % (cfg['ABS_CGI_LINK'], pwd)

load = load + """
With best regards,
  <signature>

"""

for i in range(len(values)):
        load = load + descriptions[i] + " -> " + values[i] + "\n"

load = load + '\n-- \n' + cfg['SIGNATURE']

if cfg['EMAILING']:
    msg = MIMEText(load, _charset='utf-8')
    msg['From'] = cfg['FROM_ADDR']
    msg['To'] = form.getfirst('email')
    msg['Subject'] = 'Coonf - application confirmation'
    server = smtplib.SMTP('localhost')
    server.sendmail(cfg['FROM_ADDR'], form.getfirst('email') , msg.as_string(0))
    # Admin gets name in the subject
    del msg['Subject']
    msg['Subject'] = '[Coonf appl] ' + form.getfirst('surname')
    server.sendmail(cfg['FROM_ADDR'], cfg['ADMIN'], msg.as_string(0))
    server.quit()

# [3] Writing back to browser

doc.append(Heading(2, 'Application confirmation'))
doc.append('Dear colegue, thank you for your application.')
if cfg['EMAILING']:
    doc.append("""
    Shortly, you should get an email confirming this aplication
    and correctness of entered email address. <BR>
    """)
if cfg['MODULE_ABSTRACTS'] or cfg['MODULE_UPLOADS']:
    doc.append("""
    Further data, such as abstract or your contribution to conference
    proceedings should be submitted on your private conference WWW page,
    the address of which you will get in this same email.
    <BR> <BR>
    """)
doc.append("""
In case of problems contact us at <A href="mailto:%s">
%s</A>.
<BR><P>
With best regards,<BR>
&nbsp; &nbsp; Org. committee.""" % (cfg['ADMIN'], cfg['ADMIN']))
doc.append("<BR>" + today['UPDATE'])
doc.append("<h3> Data entered: </h3>")

for i in range(len(values)):
    doc.append(descriptions[i] + " -> " + cgi.escape(values[i]) + "<BR>")

# foot and over
doc.append(foot % today)
doc.write()


